clc
clear
close all

% تعریف مقادیر اولیه
x0 = [0; 0; 0];

% تعریف مقادیر پارامترها
global r 
global Isimulous 
r= 0.0021;
Isimulous= 1;

% حل معادلات دیفرانسیل
[t, sol] = ode45(@myODE, [0, 100], x0);

% نمودار رسم شده
figure;
plot(t, sol(:, 1), 'r', 'LineWidth', 2);
hold on;
plot(t, sol(:, 2), 'g', 'LineWidth', 2);
plot(t, sol(:, 3), 'b', 'LineWidth', 2);
legend('X', 'Y', 'Z');
xlabel('زمان');
ylabel('مقدار');
title('نمودار حل معادلات دیفرانسیل');
grid on;


%% part 2

% تعداد نمونه‌ها
N = 1000;
x=zeros(1,N);
y=zeros(1,N);
z=zeros(1,N);
% مقداردهی اولیه متغیرها
x(1) = 0;
y(1) = 0;
z(1) = 0;

% ثابت ها
S1 = 1e-1;
S2 = 1e-1;
S3 = 1e-1;



% زمان
%t = 0:1:N-1;
t=linspace(0,100,N);

% معادلات گسسته شده به روش اویلر مرتبه اول
for n = 1:N-1
    x(n+1) = (y(n) + x(n)^2*(3 - x(n)) - z(n) + Isimulous) * S1 + x(n);
    y(n+1) = (1 - 5*x(n)^2 - y(n)) * S2 + y(n);
    z(n+1) = (r*(4*(x(n)+1.6) - z(n))) * S3 + z(n);
end

% محاسبه معادلات منحنی ها
f = fit(t', x', 'poly7');
disp("x(t) is:")
disp(f)
x_eq = f.p1*t.^7 + f.p2*t.^6 + f.p3*t.^5 + f.p4*t.^4 + f.p5*t.^3 + f.p6*t.^2 + f.p7*t + f.p8;

f = fit(t', y', 'poly7');
disp("y(t) is:")
disp(f)
y_eq = f.p1*t.^7 + f.p2*t.^6 + f.p3*t.^5 + f.p4*t.^4 + f.p5*t.^3 + f.p6*t.^2 + f.p7*t + f.p8;

f = fit(t', z', 'poly7');
disp("z(t) is:")
disp(f)
z_eq = f.p1*t.^7 + f.p2*t.^6 + f.p3*t.^5 + f.p4*t.^4 + f.p5*t.^3 + f.p6*t.^2 + f.p7*t + f.p8;

% رسم نمودار هریک از متغیرها به تابع زیر استفاده می‌شود:
figure;
plot(t, x, 'r', t, x_eq, 'b', 'LineWidth', 1.5);
xlabel('t');
ylabel('x');
title('نمودار x(t) در مدل گسسته‌ای با روش اویلر مرتبه اول');
legend('داده های واقعی', 'معادله منحنی');

figure;
plot(t, y, 'g', t, y_eq, 'c', 'LineWidth', 1.5);
xlabel('t');
ylabel('y');
title('نمودار y(t) در مدل گسسته‌ای با روش اویلر مرتبه اول');
legend('داده های واقعی', 'معادله منحنی');

figure;
plot(t, z, 'b', t, z_eq, 'm', 'LineWidth', 1.5);
xlabel('t');
ylabel('z');
title('نمودار z(t) در مدل گسسته‌ای با روش اویلر مرتبه اول');
legend('داده های واقعی', 'معادله منحنی');
%%

% تعریف تابع دیفرانسیل
